'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _ = require('./');

var _erschema = require('../erschema');

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

jest.mock('redux-batched-actions', function () {
  return { batchActions: function batchActions(action) {
      return action;
    } };
});
jest.mock('redux-retype-actions', function () {
  return { retypeAction: function retypeAction(name, action) {
      return action;
    } };
});
jest.mock('../action-handlers', function () {
  return {
    entityActions: {
      index: function index(entityName, entities) {
        return { entityName: entityName, entities: entities };
      }
    },
    relationshipActions: {
      index: function index(entityName, relationships) {
        return { entityName: entityName, relationships: relationships };
      }
    }
  };
});


var getId = function getId() {
  return Math.floor(Math.random() * 100000);
};
describe('Action', function () {
  var schema = {
    users: (0, _erschema.standardizeEntity)({
      Model: function Model() {
        _classCallCheck(this, Model);
      },
      properties: ['name', 'id'],
      relationships: {
        manyRelationships: {
          friends: [{}]
        },
        monoRelationships: {}
      }
    }),
    friends: (0, _erschema.standardizeEntity)({
      Model: function Model() {
        _classCallCheck(this, Model);
      },
      properties: ['name', 'id']
    })
  };

  var ActionWithSchema = function (_Actions) {
    _inherits(ActionWithSchema, _Actions);

    function ActionWithSchema(name) {
      _classCallCheck(this, ActionWithSchema);

      return _possibleConstructorReturn(this, (ActionWithSchema.__proto__ || Object.getPrototypeOf(ActionWithSchema)).call(this, schema, name));
    }

    return ActionWithSchema;
  }(_.Actions);

  var action = new ActionWithSchema('users');
  describe('creates an action instance with access to', function () {
    it('get', function () {
      var entity = { id: 1, name: 'John' };
      var results = action.actions.get(_extends({}, entity, { friends: [] }));
      expect(results).toMatchSnapshot();
    });
  });
});