'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PageActions = exports.Actions = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _reduxActions = require('redux-actions');

var _reduxRetypeActions = require('redux-retype-actions');

var _actionHandlers = require('../action-handlers');

var _resourceActionTypes = require('resource-action-types');

var _resourceActionTypes2 = _interopRequireDefault(_resourceActionTypes);

var _erschema = require('../erschema');

var _normalize = require('../normalize');

var _normalize2 = _interopRequireDefault(_normalize);

var _normalizeToStore3 = require('./normalizeToStore');

var _normalizeToStore4 = _interopRequireDefault(_normalizeToStore3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var getRelatedName = function getRelatedName(name) {
  return 'GET_RELATED_' + (0, _resourceActionTypes.generateActionName)(name);
};

var Actions = exports.Actions = function () {
  function Actions(preschema, name) {
    _classCallCheck(this, Actions);

    var schema = (0, _erschema.getSchemaWithRelationshipsArray)(preschema);
    this.constants = Object.keys(_resourceActionTypes2.default).reduce(function (finalResult, key) {
      var constant = _resourceActionTypes2.default[key](name);
      finalResult[constant] = constant;
      return finalResult;
    }, {});
    this.name = name;
    this.actions = {
      create: function create(entity) {
        return _actionHandlers.entityActions.create(name, entity);
      },
      update: function update(entity) {
        return _actionHandlers.entityActions.update(name, entity);
      },
      remove: function remove(id) {
        return _actionHandlers.entityActions.remove(name, id);
      },
      get: function get(entity) {
        return (0, _reduxRetypeActions.retypeAction)(_resourceActionTypes2.default.get(name), (0, _normalizeToStore4.default)(entity, name, schema));
      },
      index: function index(entities) {
        return (0, _reduxRetypeActions.retypeAction)(_resourceActionTypes2.default.index(name), (0, _normalizeToStore3.indexNormalizeToStore)(entities, name, schema));
      },
      getRelated: function getRelated(id, relationshipName, entities) {
        if (entities instanceof Error) {
          return (0, _reduxRetypeActions.retypeAction)(getRelatedName(name), _actionHandlers.entityActions.get(name, entities));
        }
        return (0, _reduxRetypeActions.retypeAction)(getRelatedName(name), (0, _normalizeToStore4.default)(_defineProperty({ id: id }, relationshipName, entities), name, schema));
      },
      getAdditionalEntityProperties: function getAdditionalEntityProperties(id, entityName, entity) {
        if (entity instanceof Error) {
          return _actionHandlers.entityActions.get(entityName, entity);
        }
        return (0, _reduxRetypeActions.retypeAction)('GET_ADDITIONAL_ENTITY_PROPERTIES_' + (0, _resourceActionTypes.generateActionName)(name), (0, _normalizeToStore4.default)(_extends({ id: id }, entity), name, schema));
      }
    };
  }

  _createClass(Actions, [{
    key: 'createAction',
    value: function createAction(name, payload) {
      return (0, _reduxActions.createAction)(name)(payload);
    }
  }]);

  return Actions;
}();

var PageActions = exports.PageActions = function () {
  function PageActions(preschema, prefirstSchema, name) {
    _classCallCheck(this, PageActions);

    var schema = (0, _erschema.getSchemaWithRelationshipsArray)(preschema);
    var firstSchema = (0, _erschema.getSchemaWithRelationshipsArray)(prefirstSchema);
    this.constants = Object.keys(_resourceActionTypes2.default).reduce(function (finalResult, key) {
      var constant = _resourceActionTypes2.default[key](name);
      finalResult[constant] = constant;
      return finalResult;
    }, {});

    this.actions = {
      create: function create(entity) {
        return _actionHandlers.entityActions.create('properties', _extends({}, entity, { id: name }));
      },
      update: function update(entity) {
        return _actionHandlers.entityActions.update('properties', _extends({}, entity, { id: name }));
      },
      remove: function remove() {
        return _actionHandlers.entityActions.remove('properties', name);
      },
      get: function get(entity) {
        return (0, _reduxRetypeActions.retypeAction)(_resourceActionTypes2.default.get('properties') + '_' + (0, _resourceActionTypes.generateActionName)(name), (0, _normalizeToStore4.default)(entity, 'pages', schema, firstSchema[name]));
      },
      getRelated: function getRelated(relationshipName, entities) {
        if (entities instanceof Error) {
          return _actionHandlers.entityActions.get(name, entities);
        }
        return (0, _reduxRetypeActions.retypeAction)(getRelatedName(name) + '_' + (0, _resourceActionTypes.generateActionName)(name), (0, _normalizeToStore4.default)(_defineProperty({}, relationshipName, entities), 'pages', schema, firstSchema[name]));
      }
    };
  }

  _createClass(PageActions, [{
    key: 'createAction',
    value: function createAction(name, payload) {
      return (0, _reduxActions.createAction)(name)(payload);
    }
  }]);

  return PageActions;
}();