'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = normalizeToStore;
exports.indexNormalizeToStore = indexNormalizeToStore;

var _normalize2 = require('../normalize');

var _normalize3 = _interopRequireDefault(_normalize2);

var _reduxBatchedActions = require('redux-batched-actions');

var _actionHandlers = require('../action-handlers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function normalizeToStore(entity, name, schema, firstSchema) {
  var _normalize = (0, _normalize3.default)(entity, name, schema, firstSchema),
      allEntities = _normalize.entities,
      allRelationships = _normalize.relationships;

  var entitiesForStore = Object.keys(allEntities).reduce(function (finalResult, entityName) {
    var entities = allEntities[entityName];
    var entitiesForIndex = Object.keys(entities).reduce(function (finalResult, entityId) {
      finalResult.push(entities[entityId]);
      return finalResult;
    }, []);
    finalResult.push(_actionHandlers.entityActions.index(entityName, entitiesForIndex));
    return finalResult;
  }, []);
  var relationshipsForStore = Object.keys(allRelationships).reduce(function (allRelationshipActions, entityName) {
    var relationships = allRelationships[entityName];
    var relationshipsForIndex = Object.keys(relationships).reduce(function (finalResult, relationshipName) {
      var relationship = relationships[relationshipName];
      var idValuePairs = Object.keys(relationship).reduce(function (finalResult, entityId) {
        finalResult.push({ id: entityId, value: relationship[entityId] });
        return finalResult;
      }, []);
      finalResult.push(_actionHandlers.relationshipActions.index(entityName, { name: relationshipName, idValuePairs: idValuePairs }));
      return finalResult;
    }, allRelationshipActions);
    return allRelationshipActions;
  }, []);
  return (0, _reduxBatchedActions.batchActions)([].concat(_toConsumableArray(entitiesForStore), _toConsumableArray(relationshipsForStore)));
}

function indexNormalizeToStore(entities, name, schema, firstSchema) {
  return (0, _reduxBatchedActions.batchActions)(entities.map(function (entity) {
    return normalizeToStore(entity, name, schema, firstSchema);
  }));
}