'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = function (relationshipsSchema) {
  var monoRelationships = getRelationshipArray(_relationshipTypes.ONE, relationshipsSchema.monoRelationships, []);
  return getRelationshipArray(_relationshipTypes.MANY, relationshipsSchema.manyRelationships, monoRelationships);
};

var _relationshipTypes = require('./relationshipTypes');

function getRelationshipArray(relationshipType, relationshipSchema) {
  var initialValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  var results = Object.keys(relationshipSchema).reduce(function (finalResult, relationshipName) {
    return relationshipSchema[relationshipName].reduce(function (finalFinalResult, relationshipSchema) {
      finalFinalResult.push(_extends({}, relationshipSchema, {
        name: relationshipSchema.name || relationshipName,
        alias: relationshipSchema.alias || relationshipName,
        relationshipName: relationshipName,
        type: relationshipType
      }));
      return finalFinalResult;
    }, finalResult);
  }, initialValue);
  return results;
}