'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = standardizeRelationships;

var _relationshipTypes = require('./relationshipTypes');

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function standardizeRelationships(relationshipSchemas) {
  var result = {
    // $FlowFixMe
    monoRelationships: standardizeRelationshipType(_relationshipTypes.ONE, relationshipSchemas.monoRelationships),
    // $FlowFixMe
    manyRelationships: standardizeRelationshipType(_relationshipTypes.MANY, relationshipSchemas.manyRelationships)
  };
  return result;
}

function standardizeRelationshipType(relationshipType, relationship) {
  return Object.keys(relationship).reduce(function (finalResult, relationshipName) {
    finalResult[relationshipName] = relationship[relationshipName].map(function (_ref) {
      var name = _ref.name,
          alias = _ref.alias,
          type = _ref.type,
          variableRelationshipName = _ref.variableRelationshipName,
          otherProps = _objectWithoutProperties(_ref, ['name', 'alias', 'type', 'variableRelationshipName']);

      return _extends({
        name: name || relationshipName,
        alias: alias || relationshipName,
        relationshipName: relationshipName,
        type: type || relationshipType,
        variableRelationshipName: variableRelationshipName
      }, otherProps);
    });
    return finalResult;
  }, {});
}