'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _reselect = require('reselect');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var defaultMap = new _immutable.Map();
var defaultOrderedSet = new _immutable.OrderedSet();

var bindMethods = function bindMethods(klass) {
  for (var _len = arguments.length, methodNames = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    methodNames[_key - 1] = arguments[_key];
  }

  methodNames.forEach(function (methodName) {
    //$FlowFixMe
    klass[methodName] = klass[methodName].bind(klass);
  });
};

var defaultIdSelector = function defaultIdSelector(state, props) {
  if (props && props.id) {
    return props.id;
  }
  return 0;
};

var Selector = function () {
  function Selector(erschemaReducerName, name, model) {
    _classCallCheck(this, Selector);

    this.erschemaReducerName = erschemaReducerName;
    this.name = name;
    this.defaultModel = model;
    bindMethods(this, 'findEntityData', 'getEntities', 'findEntity', 'getRelatedEntityIds', 'findRelatedEntityId', 'getRawRelatedEntityIds', 'findMonoRelationshipData', 'findManyRelationshipData');
  }

  _createClass(Selector, [{
    key: 'findEntityData',
    value: function findEntityData() {
      var _this = this;

      return (0, _reselect.createSelector)([function (state) {
        return state[_this.erschemaReducerName].entities[_this.name].data;
      }], function (entities) {
        return entities;
      });
    }
  }, {
    key: 'findManyRelationshipData',
    value: function findManyRelationshipData(relationshipName) {
      var _this2 = this;

      return (0, _reselect.createSelector)([function (state) {
        return state[_this2.erschemaReducerName].relationships[_this2.name][relationshipName];
      }], function (relationships) {
        return relationships || defaultMap;
      });
    }
  }, {
    key: 'findMonoRelationshipData',
    value: function findMonoRelationshipData(relationshipName) {
      var _this3 = this;

      return (0, _reselect.createSelector)([function (state) {
        return state[_this3.erschemaReducerName].relationships[_this3.name][relationshipName];
      }], function (relationships) {
        return relationships || defaultMap;
      });
    }
  }, {
    key: 'getEntities',
    value: function getEntities(idsSelector) {
      var _this4 = this;

      return (0, _reselect.createSelector)([idsSelector, this.findEntityData()], function (ids, entities) {
        return ids.map(function (id) {
          return entities.get('' + id) || _this4.defaultModel;
        });
      });
    }
  }, {
    key: 'findEntity',
    value: function findEntity() {
      var _this5 = this;

      var idSelector = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultIdSelector;

      return (0, _reselect.createSelector)([idSelector, this.findEntityData()], function (id, entities) {
        return entities.get('' + id) || _this5.defaultModel;
      });
    }
  }, {
    key: 'getRawRelatedEntityIds',
    value: function getRawRelatedEntityIds(relationshipName) {
      var idSelector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultIdSelector;

      return (0, _reselect.createSelector)([idSelector, this.findManyRelationshipData(relationshipName)], function (id, relationships) {
        return relationships.get('' + id) || defaultOrderedSet;
      });
    }
  }, {
    key: 'getRelatedEntityIds',
    value: function getRelatedEntityIds(relationshipName) {
      var idSelector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultIdSelector;

      return (0, _reselect.createSelector)([this.getRawRelatedEntityIds(relationshipName, idSelector)], function (ids) {
        return ids.toList();
      });
    }
  }, {
    key: 'findRelatedEntityId',
    value: function findRelatedEntityId(relationshipName) {
      var idSelector = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultIdSelector;

      return (0, _reselect.createSelector)([idSelector, this.findMonoRelationshipData(relationshipName)], function (id, relationships) {
        return relationships.get('' + id, 0);
      });
    }
  }]);

  return Selector;
}();

exports.default = Selector;