'use strict';

var _immutable = require('immutable');

var _chance = require('chance');

var _chance2 = _interopRequireDefault(_chance);

var _Selectors = require('./Selectors');

var _Selectors2 = _interopRequireDefault(_Selectors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PatientModel = function (_Record) {
  _inherits(PatientModel, _Record);

  function PatientModel() {
    _classCallCheck(this, PatientModel);

    return _possibleConstructorReturn(this, (PatientModel.__proto__ || Object.getPrototypeOf(PatientModel)).apply(this, arguments));
  }

  return PatientModel;
}((0, _immutable.Record)({ id: 0 }));

var chance = new _chance2.default();
describe('selectorUtils', function () {
  describe('Selector', function () {
    var _ref;

    var selector = new _Selectors2.default('erschema', 'patients', new PatientModel());
    var patient1 = new PatientModel({ id: chance.natural() });
    var patient2 = new PatientModel({ id: chance.natural() });
    var patient3 = new PatientModel({ id: chance.natural() });
    var woundId = chance.natural();
    var state = {
      erschema: {
        entities: {
          patients: new ((0, _immutable.Record)({ data: new _immutable.Map() }))({
            data: new _immutable.Map((_ref = {}, _defineProperty(_ref, patient1.id, patient1), _defineProperty(_ref, patient2.id, patient2), _defineProperty(_ref, patient3.id, patient3), _ref))
          })
        },
        relationships: {
          patients: new _immutable.Map({
            wounds: new _immutable.Map(_defineProperty({}, patient1.id, new _immutable.OrderedSet([woundId]))),
            wound: new _immutable.Map(_defineProperty({}, patient1.id, woundId))
          })
        }
      }
    };
    it('findEntity', function () {
      expect(selector.findEntity()(state, { id: patient1.id })).toBe(patient1);
    });
    it('findEntity returns default', function () {
      expect(selector.findEntity()(state, { id: 0 })).toEqual(new PatientModel());
    });
    it('getEntities', function () {
      expect(selector.getEntities(function () {
        return new _immutable.List([patient1.id, patient2.id]);
      })(state, {})).toEqual(new _immutable.List([patient1, patient2]));
    });
    it('getEntities return default', function () {
      expect(selector.getEntities(function () {
        return new _immutable.List([0, -1]);
      })(state, {})).toEqual(new _immutable.List([new PatientModel(), new PatientModel()]));
    });
    it('getEntityData', function () {
      expect(selector.getEntityData()(state, {})).toBe(state.erschema.entities.patients.get('data'));
    });
    it('getRelatedEntityIds', function () {
      // $FlowFixMe
      expect(selector.getRelatedEntityIds('wounds', function () {
        return patient1.id;
      })(state)).toEqual(new _immutable.List([woundId]));
    });
    it('getRelatedEntityIds returns default', function () {
      // $FlowFixMe
      expect(selector.getRelatedEntityIds('wounds', function () {
        return patient2.id;
      })(state)).toEqual(new _immutable.List());
    });
    it('findRelatedEntityId', function () {
      expect(selector.findRelatedEntityId('wound', function () {
        return patient1.id;
      })(state, {})).toEqual(woundId);
    });
    it('findRelatedEntityId returns default', function () {
      expect(selector.findRelatedEntityId('wound', function () {
        return patient2.id;
      })(state, {})).toEqual(0);
    });
  });
});